ClassFile.DeadCodeOption (Java SE 25 & JDK 25)
Description: declaration: module: java.base, package: java.lang.classfile, interface: ClassFile, enum: DeadCodeOption
Keywords: java.lang.classfile.ClassFile.DeadCodeOption class

# Enum Class ClassFile.DeadCodeOption

java.lang.Object
java.lang.Enum<ClassFile.DeadCodeOption>
java.lang.classfile.ClassFile.DeadCodeOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.DeadCodeOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.DeadCodeOption extends Enum<ClassFile.DeadCodeOption> implements ClassFile.Option
The option describing whether to patch out unreachable code for stack map generation. The default is `PATCH_DEAD_CODE` to automatically patch unreachable code and generate a valid stack map entry for the patched code.

The stack map generation process may fail when it encounters unreachable code and `KEEP_DEAD_CODE` is set. In such cases, users should set `ClassFile.StackMapsOption.DROP_STACK_MAPS` and provide their own stack maps that passes verification (JVMS 4.10.1).

See Java Virtual Machine Specification:
  4.10.1 Verification by Type Checking
Since:
  24
See Also:
  - `ClassFile.StackMapsOption`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `KEEP_DEAD_CODE`
  Keep the unreachable code for the accuracy of the generated `class` file.
  `PATCH_DEAD_CODE`
  Patch unreachable code with dummy code, and generate valid dummy stack map entries.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.DeadCodeOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.DeadCodeOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### PATCH_DEAD_CODE

    public static final ClassFile.DeadCodeOption PATCH_DEAD_CODE
    Patch unreachable code with dummy code, and generate valid dummy stack map entries. This ensures the generated code can pass verification (JVMS 4.10.1).

  - ### KEEP_DEAD_CODE

    public static final ClassFile.DeadCodeOption KEEP_DEAD_CODE
    Keep the unreachable code for the accuracy of the generated `class` file. Users should set `ClassFile.StackMapsOption.DROP_STACK_MAPS` to prevent stack map generation from running and provide their own `StackMapTableAttribute` to a `CodeBuilder`.

- ## Method Details

  - ### values

    public static ClassFile.DeadCodeOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.DeadCodeOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null